<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\sale;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\sale\Sale;
use app\common\lists\ListsSearchInterface;
use think\facade\Db;


/**
 * Sale列表
 * Class SaleLists
 * @package app\adminapi\lists
 */
class PropertyHeadAnalysisLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public function setSearch(): array
    {
        return [
            '=' => ['sale_group_id', 'property_head_id','sale_type', 'sale_id'],

        ];
    }

    public function queryWhere()
    {
        $where = [];
        if(isset($this->params['time_range']) && $this->params['time_range']){
            $startDateTime = strtotime($this->params['time_range'][0]);
            $endDateTime = strtotime($this->params['time_range'][1])+86400-1;
            $where[] = ['b.finished_time','BETWEEN',[$startDateTime,$endDateTime]];
        }
        return $where;
    }
    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public function lists(): array
    {
        return Db::name('property_order')->alias('a')
            ->leftJoin('service_work b', 'a.work_id = b.id')
            ->leftJoin('property_head c', 'a.property_head_id = c.id')
            ->leftJoin('sale d', 'a.sale_id = d.id')
            ->field([
                'a.property_head_id','c.property_name','c.village_name','c.address','c.head_name','c.head_mobile','d.sale_name',
                Db::raw("COUNT(a.work_id) AS work_count,SUM(b.work_amount) AS total_sales_amount")
            ])
            ->where('a.sale_type', 'in', [1, 2])
            ->where('a.order_status', 3)
            ->group('a.property_head_id')
            ->limit($this->limitOffset, $this->limitLength)
            ->select()->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2024/12/15 10:53
     */
    public function count(): int
    {
        return Db::name('property_order')->alias('a')
            ->leftJoin('service_work b', 'a.work_id = b.id')
            ->leftJoin('sale c', 'a.sale_id = c.id')
            ->field([
                'a.property_head_id','c.sale_name','c.mobile',
                Db::raw("COUNT(a.work_id) AS work_count,SUM(b.work_amount) AS total_sales_amount")
            ])
            ->where('a.sale_type', 'in', [1, 2])
            ->where('a.order_status', 3)
            ->group('a.property_head_id')
            ->count();
    }

}